routes/web.php
<?php

use App\Http\Controllers\ContactsController;
use App\Http\Controllers\ApplicantsController;
use App\Http\Controllers\BackupController;
use App\Http\Controllers\CompanyController;
use App\Http\Controllers\CourseController;
use App\Http\Controllers\DealController;
use App\Http\Controllers\DriveController;
use App\Http\Controllers\EvaluationController;
use App\Http\Controllers\InternshipsController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\ModuleController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\QuarterController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\TeamController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Storage;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

require __DIR__.'/auth.php';
Route::group(['middleware'=>'auth'],function(){
    Route::view('/dashboard','dashboard')->name('dashboard');
    Route::view('/home', 'welcome')->name('home');
    Route::resource('/contacts'     ,ContactsController::class);
    Route::resource('/teams'        ,TeamController::class);
    Route::resource('/projects'     ,ProjectController::class);
    Route::resource('/tasks'        ,TaskController::class);
    Route::resource('/courses'       ,CourseController::class);
    Route::resource('/invoices'     ,InvoiceController::class);
    Route::resource('/quarters'     ,QuarterController::class);
    Route::resource('/modules'      ,ModuleController::class);
    Route::resource('/evaluations'  ,EvaluationController::class);
    Route::resource('/deals'        ,DealController::class);
    Route::resource('/companies'    ,CompanyController::class);
    Route::resource('/roles'        ,RoleController::class);
    Route::resource('/applicants'   ,ApplicantsController::class);
    Route::resource('/internships'  ,InternshipsController::class);
    Route::get('/applicants_import',[ApplicantsController::class,'import']);
    Route::get('/applicants_export',[ApplicantsController::class,'export'])->name('applicants.export');
    Route::get('/contacts_import',[ContactsController::class,'import']);
    Route::get('/contacts_export',[ContactsController::class,'export'])->name('contacts.export');


    Route::put('/internship_applicant/{id}/update_status',[InternshipsController::class,'update_status'])->name('internship.update_status');
});

Route::get('/', function () {
    return redirect()->route('login');
});

Route::get('/testdrive',[DriveController::class , 'index']);

    // // Backup routes
    // Route::get('backup',  [BackupController::class,'index']);
    // Route::get('backup/create',  [BackupController::class,'create']);
    // Route::get('backup/download/{file_name}', [BackupController::class,'download']);
    // Route::get('backup/delete/{file_name}',  [BackupController::class,'delete']);

app/Models/Applicant.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Applicant extends SuperScope
{
    use HasFactory;
    protected $fillable=['name','age','email','cv','major','year','phone','uni','city'];
    public function internships()
    {
        return $this->belongsToMany('App\Models\Internship', 'internship_applicant', 'applicant_id', 'internship_id')->withPivot(['status','id'])->withTimestamps();
    }

    public function internship($id){
        return ($this->internships()->withPivot('status')->where('internships.id',$id)->first()->pivot);
    }

}

app/Models/Internship.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Internship extends SuperScope
{
    use HasFactory;
    const STATUS_REQUESTED = 1;
    const STATUS_UNDER_REVIEW = 2;
    const STATUS_TO_INTERVIEW = 3;
    const STATUS_ACCEPTED = 4;
    const STATUS_REJECTED = 5;
    const STATUS_ONLINE= 6;
    const STATUS_OFFLINE = 7;

    protected $fillable = ['name', 'subject', 'description'];
    public function applicants()
    {
        return $this->belongsToMany(Applicant::class, 'internship_applicant', 'internship_id', 'applicant_id')->withTimestamps();
    }

    public function accepted_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_ACCEPTED);
    }
    public function under_review_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_UNDER_REVIEW);
    }
    public function rejected_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_REJECTED);
    }
    public function to_interview_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_TO_INTERVIEW);
    }
    public function requested_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_REQUESTED);
    }
    public function online_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_ONLINE);
    }
    public function offline_applicants()
    {
        return $this->applicants()->where('status', Internship::STATUS_OFFLINE);
    }

}

app/Http/Controllers/ApplicantsController.php
<?php

namespace App\Http\Controllers;

use App\Exports\ApplicantsExport;
use App\Http\Misc\Helpers\Config;
use App\Imports\ApplicantsImport;
use App\Models\Applicant;
use Illuminate\Http\Request;
use Maatwebsite\Excel\Facades\Excel;

class ApplicantsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        //
        $data = Applicant::with('internships');
        $data = $data->searchIn(["name", "email", "uni", 'major', 'city'], $request->search_input);
        $data = $data->paginate(Config::PAGINATION_LIMIT)->withQueryString();
        $name = 'applicants';

        return view('applicants.index', compact('data', 'name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    public function import()
    {
        Excel::import(new ApplicantsImport, 'applicants3.csv');

        return back()->with(["message" => "Imported Successfully!"]);
    }
    public function export()
    {
        $applicants =  Applicant::get()->makeHidden(['created_at','updated_at']);
        return Excel::download(new ApplicantsExport($applicants), 'applicants-' . now() . '.csv');
    }
}

app/Http/Controllers/InternshipsController.php
<?php

namespace App\Http\Controllers;

use App\Exports\ApplicantsExport;
use App\Http\Misc\Helpers\Config;
use App\Models\Applicant;
use App\Models\Internship;
use App\Models\InternshipApplicant;
use Illuminate\Http\Request;
use Maatwebsite\Excel\Facades\Excel;

class InternshipsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        //
        $data = Internship::withCount(['applicants', 'accepted_applicants', 'rejected_applicants', 'requested_applicants', 'to_interview_applicants', 'under_review_applicants','online_applicants','offline_applicants']);
        $data = $data->searchIn(["name"], $request->search_input);
        $data = $data->paginate(Config::PAGINATION_LIMIT)->withQueryString();
        $name = 'internships';

        return view('internships.index', compact('data', 'name'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request, Internship $internship)
    {
        //
        $data = $internship->applicants()->exactValue('status', $request->status)->with('internships');
        $data = $data->searchIn(["name", "email", "uni", 'major', 'city'], $request->search_input);

        if ($request->export) {
            $applicants =  $data->get()->makeHidden(['created_at', 'updated_at']);
            return Excel::download(new ApplicantsExport($applicants), 'applicants-' . now() . '.csv');
        }

        $data = $data->paginate(Config::PAGINATION_LIMIT)->withQueryString();
        $name = 'applicants';
        return view('internships.applicants.index', compact('data', 'name'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update_status(Request $request,  $id)
    {

        //
        $item = InternshipApplicant::find($id);
        $item->status = $request->status;
        $item->save();
        return back()->with(['message' => 'Updated']);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/internships/applicants/index.blade.php
<x-app-layout>
    @php
        $create = ['btn_name' => 'Add Applicant  ', 'type' => 'modal', 'method' => 'POST', 'name' => 'Add New Applicant', 'route' => [$name . '.store', [$name]], 'action_route' => [$name . '.store', [$name]]];

    @endphp
    <x-slot name="content">
        <x-top-nav>
            <div class="d-block mb-4 mb-md-0">
                <x-top-nav-bread>
                    <li class="breadcrumb-item active"><a href="{{ route('internships.index') }}">Internships</a></li>
                    <li class="breadcrumb-item active"><a
                            href="{{ route($name . '.index') }}">{{ ucfirst($name ?? '') }}</a></li>

                </x-top-nav-bread>
                <h2 class="h4 mb-0">{{ ucfirst($name ?? '') }} </h2>
                <p class="mb-2">This {{ $name ?? '' }} dashboard to manage it .</p>
            </div>

        </x-top-nav>

        <x-action-modal-btn :operation="$create"><span class="fas fa-plus me-2"></span></x-action-modal-btn>
        <x-action-modal :operation="$create">
            @include('forms.applicants.create')
            <div class="d-grid">
                <x-button type="submit" class="btn btn-dark">Add New Applicant </x-button>
            </div>
        </x-action-modal>
        <x-searchbar
            route="{{ route('internships.show', [request()->internship->id, 'status' => request()->query('status')]) }}">
            <div class="d-flex justify-content-end">
                <a href={{ route('internships.show', [request()->internship->id, 'status' => request()->query('status'), 'export' => 'csv']) }}
                    class=' btn btn-sm btn-primary   pe-1 text-white  '><span class="fas fa-file-csv me-1"></span>
                    Export Report
                </a>
        </x-searchbar>
        <x-table>
            <x-slot name="filters">
                <a href="{{ route('internships.show', [request()->internship->id]) }}"
                    class="btn btn-xs btn-primary ">All</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_REQUESTED]) }}"
                    class="btn btn-xs btn-outline-info @if (request()->query('status') ==
                    App\Models\Internship::STATUS_REQUESTED) btn-info text-white @endif">Requested</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_UNDER_REVIEW]) }}"
                    class="btn btn-xs btn-outline-warning @if (request()->query('status') ==
                    App\Models\Internship::STATUS_UNDER_REVIEW) btn-warning text-white @endif">Under Review</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_TO_INTERVIEW]) }}"
                    class="btn btn-xs btn-outline-warning @if (request()->query('status') ==
                    App\Models\Internship::STATUS_TO_INTERVIEW) btn-warning text-white @endif">To Interview</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_ACCEPTED]) }}"
                    class="btn btn-xs btn-outline-success @if (request()->query('status') ==
                    App\Models\Internship::STATUS_ACCEPTED) btn-success text-white @endif">Accepted</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_ONLINE]) }}"
                    class="btn btn-xs btn-outline-success @if (request()->query('status') ==
                    App\Models\Internship::STATUS_ONLINE) btn-success text-white @endif">Online</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_OFFLINE]) }}"
                    class="btn btn-xs btn-outline-success @if (request()->query('status') ==
                    App\Models\Internship::STATUS_OFFLINE) btn-success text-white @endif">Offline</a>
                <a href="{{ route('internships.show', [request()->internship->id, 'status' => App\Models\Internship::STATUS_REJECTED]) }}"
                    class="btn btn-xs btn-outline-danger @if (request()->query('status') ==
                    App\Models\Internship::STATUS_REJECTED) btn-danger text-white @endif">Rejected</a>

            </x-slot>
            <x-slot name="header">
                <x-table-h data-priority="0">#</x-table-h>
                <x-table-h data-priority="1">Status</x-table-h>
                <x-table-h data-priority="1">CV </x-table-h>
                <x-table-h data-priority="1">Full Name</x-table-h>
                <x-table-h data-priority="0">Email</x-table-h>
                <x-table-h data-priority="0">Phone</x-table-h>
                <x-table-h data-priority="1">Age</x-table-h>
                <x-table-h data-priority="1">City</x-table-h>
                <x-table-h data-priority="1">University</x-table-h>
                <x-table-h data-priority="1">Major</x-table-h>
                <x-table-h data-priority="1">Internships</x-table-h>

            </x-slot>
            <x-slot name="body">
                @foreach ($data as $row)
                    @php
                        $change_status = ['btn_name' => '', 'type' => 'modal', 'method' => 'PUT', 'name' => 'Change Status', 'route' => ['internship.update_status', [$row->internship(request()->internship->id)->id]], 'action_route' => ['internship.update_status', [$row->internship(request()->internship->id)->id]]];

                    @endphp

                    <tr>
                        <x-table-b>{{ $row->id }}</x-table-b>
                        <x-table-b>
                            <x-action-modal-basic-btn :operation="$change_status">
                                <small>
                                    <x-multi-value
                                        :values="['Requested','Under Review','To Interview','Accepted','Rejected','Online','Offline']"
                                        :value="$row->internship(request()->internship->id)->status"
                                        :classes="['badge bg-info p-1','badge bg-warning p-1','badge bg-warning p-1','badge bg-success p-1','badge bg-danger p-1','badge bg-success p-1','badge bg-success p-1']" />
                                </small>
                            </x-action-modal-basic-btn>
                        </x-table-b>
                        <x-table-b><a href={{ $row->cv }} target="_blank" class="text-success">View</a>
                        </x-table-b>
                        <x-table-b>{{ $row->name }}</x-table-b>
                        <x-table-b>{{ $row->email }}</x-table-b>
                        <x-table-b>{{ $row->phone }}</x-table-b>
                        <x-table-b>{{ $row->age }}</x-table-b>
                        <x-table-b>{{ $row->city }}</x-table-b>
                        <x-table-b>{{ $row->uni }}</x-table-b>
                        <x-table-b>{{ $row->major }}</x-table-b>
                        <x-table-b>
                            @foreach ($row->internships as $item)
                                <div class="badge bg-dark">{{ Str::ucfirst($item->name) }}</div>
                            @endforeach

                        </x-table-b>

                    </tr>
                    <x-action-modal :operation="$change_status">
                        @include('forms.internships.edit')
                        <div class="d-grid">
                            <x-button type="submit" class="btn btn-dark">Change Status </x-button>
                        </div>
                    </x-action-modal>

                @endforeach

            </x-slot>
            <x-slot name="footer">
                {{ $data->links('vendor.pagination.bootstrap-4') }}

            </x-slot>

        </x-table>
    </x-slot>
</x-app-layout>